package com.ruoyi.ai.service.impl;

import java.util.List;
import com.baomidou.mybatisplus.core.conditions.query.LambdaQueryWrapper;
import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.baomidou.mybatisplus.core.toolkit.Wrappers;
import com.baomidou.mybatisplus.core.metadata.IPage;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.ruoyi.common.exception.ServiceException;
import com.ruoyi.common.utils.DateUtils;
import com.ruoyi.common.utils.SecurityUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import com.ruoyi.ai.mapper.AiTemplateMapper;
import com.ruoyi.ai.domain.AiTemplate;
import com.ruoyi.ai.service.IAiTemplateService;

/**
 * AI模版Service业务层处理
 * 
 * @author shi
 * @date 2026-01-15
 */
@Service
public class AiTemplateServiceImpl implements IAiTemplateService {

    @Autowired
    private AiTemplateMapper aiTemplateMapper;

    /**
     * 查询AI模版
     * 
     * @param id AI模版主键
     * @return AI模版
     */
    @Override
    public AiTemplate selectAiTemplateById(Long id) {
        return aiTemplateMapper.selectById(id);
    }

    /**
     * 查询AI模版列表
     * 
     * @param aiTemplate AI模版
     * @return AI模版
     */
    @Override
    public List<AiTemplate> selectAiTemplateList(AiTemplate aiTemplate) {
        LambdaQueryWrapper<AiTemplate> query = Wrappers.lambdaQuery(aiTemplate);
        query.orderByDesc(AiTemplate::getId);
        query.eq(AiTemplate::getDelFlag, "0");
        return aiTemplateMapper.selectList(query);
    }

    /**
     * 分页查询AI模版列表
     *
     * @param aiTemplate AI模版
     * @return AI模版
     */
    @Override
    public IPage<AiTemplate> selectAiTemplatePage(Page page, AiTemplate aiTemplate) {
        LambdaQueryWrapper<AiTemplate> query = Wrappers.lambdaQuery(aiTemplate);
        query.eq(AiTemplate::getDelFlag, "0");
        return aiTemplateMapper.selectPage(page, query);
    }

    /**
     * 新增AI模版
     * 
     * @param aiTemplate AI模版
     * @return 结果
     */
    @Override
    public int insertAiTemplate(AiTemplate aiTemplate) {
        aiTemplate.setDelFlag("0");
        aiTemplate.setCreateTime(DateUtils.getNowDate());
        aiTemplate.setCreateBy(SecurityUtils.getUsername());
        return aiTemplateMapper.insert(aiTemplate);
    }

    /**
     * 修改AI模版
     * 
     * @param aiTemplate AI模版
     * @return 结果
     */
    @Override
    public int updateAiTemplate(AiTemplate aiTemplate) {
        aiTemplate.setUpdateBy(SecurityUtils.getUsername());
        aiTemplate.setUpdateTime(DateUtils.getNowDate());
        return aiTemplateMapper.updateById(aiTemplate);
    }

    /**
     * 批量删除AI模版
     * 
     * @param ids 需要删除的AI模版主键
     * @return 结果
     */
    @Override
    public int deleteAiTemplateByIds(Long[] ids)
    {
        return aiTemplateMapper.deleteAiTemplateByIds(ids);
    }

    /**
     * 删除AI模版信息
     * 
     * @param id AI模版主键
     * @return 结果
     */
    @Override
    public int deleteAiTemplateById(Long id)
    {
        return aiTemplateMapper.deleteAiTemplateById(id);
    }
}
